//---------------------------------------------------------------------//
//                                                                     //
//                                                                     //
//  @      @  P/ECE gCOM|[g񓯊VAʐMhCo          //
//                                                                     //
//                              serial.c                               //
//                                                                     //
//                            version 1.02                             //
//                                                                     //
//---------------------------------------------------------------------//

// Written by: skato@ycf.nanet.co.jp
// modified by: hitode@aw.wakwak.com

//#define	SERIAL_ORG	//̃V{`΁ÃR[hɖ߂܂

#include <stdio.h>
#include <stdlib.h>
#include <piece.h>
#include </usr/piece/sysdev/pcekn/pcekn.h>
#include "serial.h"

/* CPU24MHẑƂ̃NbN RLD  pdr ,eNjJ}jA p.332Q */
/*                   bps =   300  1200  2400  4800  9600 14400 28800     */
const unsigned char Rld[]={  155,  155,  155,   77,   38,   12,   12 };
const unsigned char Pdr[]={ 0x30, 0x10, 0x00, 0x00, 0x00, 0x10, 0x00 };

tagCOMBuf COMRx;
tagCOMBuf COMTx;

void COMDisable();
void COMEnable();
extern void intr_recv(void);
extern void intr_send(void);

int recvcount=0;
int sendcount=0;
//-------------------------------------------------------------------------
// API
//

void COMOpen(int mode,int bps)
{
	volatile unsigned char *bp = iop_c;

	COMDisable();
	
	// CFP0 :o͒[q̐ݒ
	bp[0x2D0] |= 0x30;	// P07 -
						// P06 -
						// P05 1 SOUT1
						// P04 1 SIN1
						// P03 -
						// P02 -
						// P01 -
						// P00 -
	
	// Ch.1 C^tF[X[hݒ
	bp[0x1E9] &= ~0x03;	// IRMD1 0 ʏI/F
	
	// ][h̐ݒ
	bp[0x1E8] = mode&0x3;
	
	// ̓NbN̐ݒ
	bp[0x1E8] &= ~0x04;		// D2 SSCK1   0 NbNgp
	bp[0x146] &= ~0x04;		// D3 P8TPCK3 0 L
	bp[0x1E9] &= ~0x10;     // D4 DIVMD1  0 NbN1/16Ɂi1)
	bp[0x14E] &= ~0x70;		//    P8TS3     NA
	bp[0x14E] |=  Pdr[bps];	//    P8TS3     8Bit^C}Ch.3̕ݒ	
	bp[0x16D]  =  Rld[bps];	//    RLD3      8Bit^C}Ch.3̃[hf[^ݒ
	bp[0x16C] |= 0x07;		// D2 PTOUT3  1 ^C}o͋
							// D1 PSET3	  1 RLDl̃vZbg
							// D0 PTRUN3  1 JEgX^[g
	
	/* PF}jA p.B-III-8-15 5sڂ̋Lq͊ԈႢ */

	// f[^tH[}bg̐ݒ
	bp[0x1E8] = mode;	// Đݒ肪KvH
		
	// 荞݃xN^̐ݒ
	pceVectorSetTrap(61,intr_recv);
	pceVectorSetTrap(62,intr_send);

	// IDMANGXgWX^̐ݒ
	bp[0x293] &= ~0x03;	// D1 RSTX1 0 荞ݗv
						// D0 RSRX1 0 荞ݗv
						
	// 荞ݗṽZbg
	bp[0x286] &= ~0x34;	// D5 FSTX1  0 Mobt@GveB
						// D4 FSRX1	 0 Mobt@t
						// D3 FSERR1 0 MG[
	
	// 荞݂̋
	bp[0x276] |= 0x10;	// D4 ESRX1  1 Mobt@t荞:
	bp[0x276] &= ~0x24;	// D5 ESTX1  0 Mobt@GveB荞݁F֎~
						// D4 -
						// D3 ESERR1 0 MG[荞݁F֎~
	
	COMRx.tail=0;
	COMRx.head=0;
	COMTx.tail=0;
	COMTx.head=0;

	COMEnable();
}

void COMClose()
{
	COMDisable();
}

int COMGetch(void)
{
	int ch;
	if(COMRx.tail == COMRx.head)
	{
		return COM_EMPTY;
	}
	
	ch=COMRx.buff[COMRx.tail];
#ifdef	SERIAL_ORG
	COMRx.tail++;
	COMRx.tail &= COM_BUFSIZE-1;
#else
	COMRx.tail = (COMRx.tail+1)&(COM_BUFSIZE-1);
#endif
	return ch;
}

void COMPutch(unsigned char ch)
{
	volatile unsigned char *bp=iop_c;
	
#ifdef	SERIAL_ORG
	COMTx.buff[COMTx.head] = ch;
	COMTx.head++;
	COMTx.head &= COM_BUFSIZE-1;
	if(COMTx.head ==COMTx.tail) // I[o[t[
	{
		++COMTx.tail;
		COMTx.tail &= COM_BUFSIZE-1;
	}

	// MĂΑMĊJ
	if(!(bp[0x276] & 0x20)) 
	{
		bp[0x1E5] = COMTx.buff[COMTx.tail];
		COMTx.tail++;
		COMTx.tail &= COM_BUFSIZE-1;

		bp[0x286] &= ~0x20;	// Mobt@GveBvtÕZbg
		bp[0x276] |= 0x20;	// D5 ESTX1 1 Mobt@GveB荞݂̋
	}
#else
	if(((COMTx.head+1)&(COM_BUFSIZE-1))==COMTx.tail){
		return;		//send buffer full
	}
	COMTx.buff[COMTx.head] = ch;
	COMTx.head = (COMTx.head+1)&(COM_BUFSIZE-1);
	// MĂΑMĊJ
	if(!(bp[0x276] & 0x20)) 
	{
		bp[0x1E5] = COMTx.buff[COMTx.tail];
		COMTx.tail++;
		COMTx.tail &= COM_BUFSIZE-1;

		SET_SIL7;
		bp[0x29f] |=  0x01;	//reset only
		bp[0x286]  =  0x20;	// Mobt@GveBvtÕZbg
		bp[0x29f] &= ~0x01;	//rd/wr
		bp[0x276] |= 0x20;	// D5 ESTX1 1 Mobt@GveB荞݂̋
		SET_SIL0;

	}
#endif
}

void COMPutStr(unsigned char *str)
{
	//volatile unsigned char *bp=iop_c;
	char *ptr=str;
	while(*ptr)
	{
		COMPutch(*ptr);
		ptr++;
	}
}

//-----------------------------------------------------------------------
// 
//


void _intr_recv(void)
{
	asm("intr_recv:");
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		
		bp[0x276] &= ~0x10; // M荞 ֎~
			recvcount++;		
#ifdef	SERIAL_ORG
		COMRx.buff[COMRx.head] =bp[0x1E6];
		COMRx.head++;
		COMRx.head &= COM_BUFSIZE-1;
		if(COMRx.head == COMRx.tail)
		{
			++COMRx.tail;
			COMRx.tail &= COM_BUFSIZE-1;

		}
		bp[0x286] &= ~0x10;	// Mobt@tvtÕZbg
		bp[0x276] |= 0x10;	// Mobt@t荞݂̋
#else
		if(((COMRx.head+1)&(COM_BUFSIZE-1))!=COMRx.tail){
			COMRx.buff[COMRx.head] =bp[0x1E6];
			COMRx.head = (COMRx.head+1)&(COM_BUFSIZE-1);
		}
		//test clear only
		SET_SIL7;
		bp[0x29f] |=  0x01;	//reset only
		bp[0x286]  =  0x10;	// Mobt@tvtÕZbg
		bp[0x29f] &= ~0x01;	//rd/wr
		bp[0x276] |= 0x10;	// Mobt@t荞݂̋
#endif
	}
	INT_END2;
}

void _intr_send(void)
{
	asm("intr_send:");
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		sendcount++;
		bp[0x276] &= ~0x20; // Mobt@GveB荞݂̋֎~
		if(COMTx.tail == COMTx.head)
		{
			INT_END2;
			return; 
		}
		
		bp[0x1E5] = COMTx.buff[COMTx.tail];
		COMTx.tail++;
		COMTx.tail &= COM_BUFSIZE-1;
		
#ifdef	SERIAL_ORG
		// Mp
		bp[0x286] &= ~0x20;	// Mobt@GveBvtÕZbg
		bp[0x276] |= 0x20;	// Mobt@GveB荞݂̋
#else

		//test clear only
		SET_SIL7;
		bp[0x29f] |=  0x01;	//reset only
		bp[0x286] = 0x20;	// Mobt@GveBvtÕZbg
		bp[0x29f] &= ~0x01;	//rd/wr
		bp[0x276] |= 0x20;	// Mobt@GveB荞݂̋
#endif
	}
	
	INT_END2;
}

void COMDisable(void)
{
	volatile unsigned char *bp = iop_c;
	
	COMTx.head=0;
	COMTx.tail=0;

/*	Mobt@ɂȂ̂҂
	int count =RETRY0;

	while(bp[0x1E7] & 0x20)
	{
		count--;
		if(!count) break;
	}
*/	
	// VAC^tF[X̑M֎~
	bp[0x1E8] &= ~0xC0;	// D7 TXEN1 0
						// D6 RXEN1 0
	// NbN~
	bp[0x14E] &= ~0x80;	// D7 P8TON3 0
}

void COMEnable(void)
{
	volatile unsigned char *bp = iop_c;
	
	//NbNJn
	bp[0x14E] |= 0x80;	// D7 P8TON3 1
	
	// VAC^tF[X̑M
	bp[0x1E8] |= 0xC0;	// D7 TXEN 1
						// D6 RXEN 1
}

